/*
** Copyright (c) 2001-2005, Oracle Corporation. All Rights Reserved.
**
**34567890123456789012345678901234567890123456789012345678901234567890123456789
*/

/*
**Test
*/

function EncodingFormat(
  length,
  messages
  )
{
  this._length   = length;
  this._messages = messages;
  this._class    = "EncodingFormat";
}

EncodingFormat.prototype = new Validator();

//LF - Length failed
EncodingFormat.prototype.LF  = "LF";

function _cjkParse(
  parseString
  )
{
  var i = 0;
  var length = this._length;

  while (i < parseString.length)
  { 
    var ch = parseString.charCodeAt(i);
    if ((ch < 0x80) || ((0xFF60 < ch) && (ch < 0xFFA0))) length--; 
    else length -= 2;
   
    if (length < 0)
    {
      return new ValidatorException(this._messages[this.LF]);     
    }

    i++;
  }

  return parseString;
}


function CjkFormat(
  length,
  messages
  )
{
  this._base = EncodingFormat;
  this._base(length, messages);
  this._class = "CjkFormat";
  
}


CjkFormat.prototype = new EncodingFormat();
CjkFormat.prototype.validate  = _cjkParse;

function _utf8Parse(
  parseString
  )
{
  var i = 0;
  var length = this._length;

  while (i < parseString.length)
  { 
    var ch = parseString.charCodeAt(i);
    if (ch < 0x80) length--;
    else if (ch < 0x800) length -= 2;
    else
    {
      // Surrogates;  see bug 3849516
      if ((ch & 0xF800) == 0xD800)
        length -= 2;
      else
        length -= 3;
    }

    if (length < 0)
    {
      return new ValidatorException(this._messages[this.LF]);            
    }

    i++;
  }

  return parseString;
}


function Utf8Format(
  length,
  messages
  )
{
  this._base = EncodingFormat;
  this._base(length, messages);
  this._class = "Utf8Format";
}


Utf8Format.prototype = new EncodingFormat();
Utf8Format.prototype.validate  = _utf8Parse;



function _sbParse(
  parseString
  )
{
  if (this._length < parseString.length)
  {
    return new ValidatorException(this._messages[this.LF]);    
  }

  return parseString;
}


function SBFormat(
  length,
  messages
  )
{
  this._base = EncodingFormat;
  this._base(length, messages);
  this._class = "SBFormat";
  
}


SBFormat.prototype = new EncodingFormat();
SBFormat.prototype.validate  = _sbParse;


