////////////////////////////////////////////////////////////////////////////////
// The custom object for managing poll related services at the client.
//  Service provided currently is...
//  1. Store poll commands (usually the setTimeOut command), and the id
//  resulting out of activating (eval) it, keyed by the poll id (typically the  
//  id's of pollcomponents themselves)
//  2. Add and activate a poll command.
//  3. Reactivate all the poll commands that were set earlier.
////////////////////////////////////////////////////////////////////////////////
function _PollManager()
{
  this.pollIdList;
  this.active = true;
}
_PollManager.prototype.addAndActivate = _addAndActivatePoll;
_PollManager.prototype.deactivateAll  = _deactivateAllPoll;
_PollManager.prototype.reactivateAll  = _reactivateAllPoll;

// Adds a command (replaces one that already exists with the same poll id)
//  and executes it right away.
function _addAndActivatePoll(pollId, commandString, timeout)
{
  if (!this.pollIdList)
    this.pollIdList = new Array();
  this[pollId] = new _PollCommand(commandString, timeout, this.active);
  idIndex = -1;
  for (var i=0; i<this.pollIdList.length; i++)
  {
    if (pollId == this.pollIdList[i])
    {
      idIndex = i;
      break;
    }
  }
  if (idIndex != -1)
  {
    this.pollIdList[idIndex] == pollId;
  }
  else
  {
    this.pollIdList.push(pollId);
  }
}

// Deactivate all the registered poll commands.
function _deactivateAllPoll()
{
  for (var i=0; i<this.pollIdList.length; i++)
  {
    clearTimeout(this[this.pollIdList[i]].commandId);
  }
  this.active = false;
}

// Reactivate all the registered poll commands.
function _reactivateAllPoll()
{
  for (var i=0; i<this.pollIdList.length; i++)
  {
    this[this.pollIdList[i]].activate();
  }
  this.active = true;
}

////////////////////////////////////////////////////////////////////////////////
// Custom object representing a poll command.
////////////////////////////////////////////////////////////////////////////////
function _PollCommand(commandString, timeout, activate)
{
  this.commandString = commandString;
  this.timeout = timeout;
  if (activate)
    this.activate();
}
_PollCommand.prototype.activate = _activatePoll;

function _activatePoll()
{
  this.commandId = setTimeout(this.commandString, this.timeout);
}

