// ----- BEGIN: APIs for Rich Text Editor -----
function RichTextEditorProxy(formName,beanId, mode, maxLength, browserFlag)
{
  this.formName = formName;
  this.beanId = beanId + "_IFRAME";
  this.dataBeanId = beanId;
  this.mode = mode;
  this.maxLength  = maxLength;
  this.browserFlag = browserFlag;  // "IE_Win", "Mozilla" or "Other"
  this.maxLengthAlertMsgStr = "";
}

RichTextEditorProxy.prototype.onMouseOver          = _onMouseOver;
RichTextEditorProxy.prototype.onMouseOut           = _onMouseOut;
RichTextEditorProxy.prototype.onMouseDown          = _onMouseDown;
RichTextEditorProxy.prototype.onMouseUp            = _onMouseUp;
RichTextEditorProxy.prototype.createHyperlink      = _createHyperlink;
RichTextEditorProxy.prototype.execHTMLCommand      = _execHTMLCommand;
RichTextEditorProxy.prototype.getField             = _getField;
RichTextEditorProxy.prototype.setFontBarDropdown   = _setFontBarDropdown;
RichTextEditorProxy.prototype.insertHTMLTag        = _insertHTMLTag;
RichTextEditorProxy.prototype.setContentOnBlur     = _setContentOnBlur;
RichTextEditorProxy.prototype.insertText           = _insertText;
RichTextEditorProxy.prototype.insertImageTag       = _insertImageTag;
RichTextEditorProxy.prototype.setValue             = _setValue;
RichTextEditorProxy.prototype.setHref              = _setHref;
RichTextEditorProxy.prototype.viewHtmlSource       = _viewHtmlSource;
RichTextEditorProxy.prototype.disableFontDropDowns = _disableFontDropDowns;
RichTextEditorProxy.prototype.checkRTEDataLength   = _checkRTEDataLength;
RichTextEditorProxy.prototype.validateContent      = _validateContent;
RichTextEditorProxy.prototype.setMaxLengthAlert    = _setMaxLengthAlert;
RichTextEditorProxy.prototype.getMaxLengthAlert    = _getMaxLengthAlert;

function _onMouseOver()
{
  if (window.getSelection) {
    this.style.border="outset 2px";
  }
  else if (document.selection)
  {
    var toEl = getReal(window.event.toElement, "className", this.className);
    var fromEl = getReal(window.event.fromElement, "className", this.className);
    if (toEl == fromEl) return;
    var el = toEl;

    var cDisabled = el.getAttribute("cDisabled");
    cDisabled = (cDisabled != null);

    if (el.className == this.className)
      el.onselectstart = new Function("return false");

    if ((el.className == this.className) && !cDisabled)
    {
      makeRaised(el);
    }
  }
}

function _onMouseOut()
{
  if( window.getSelection)
  {
    this.style.border="solid 2px #C0C0C0";
  }
  else if (document.selection)
  {
    var toEl = getReal(window.event.toElement, "className", this.className);
    var fromEl = getReal(window.event.fromElement, "className", this.className);
    if (toEl == fromEl)
      return;
    var el = fromEl;
    var PressedEx = el.getAttribute("PressedEx");
    var cDisabled = el.getAttribute("cDisabled");
    cDisabled = (cDisabled != null);

    var cToggle = el.getAttribute("cToggle");
    toggle_disabled = (cToggle != null);

    if (cToggle && el.value || PressedEx == true)
    {
      makePressed(el);
    }
    else if ((el.className == this.className) && !cDisabled)
    {
      makeFlat(el);
    }
  }
}

function _onMouseDown(e)
{
  if( window.getSelection)
  {
    this.firstChild.style.left = 2;
    this.firstChild.style.top = 2;
    this.style.border="inset 2px";
    e.preventDefault();
  }
  else if (document.selection)
  {
    el = getReal(window.event.srcElement, "className", this.className);
    var cDisabled = el.getAttribute("cDisabled");
    cDisabled = (cDisabled != null);
    if ((el.className == this.className) && !cDisabled)
    {
      makePressed(el);
    }
  }
}

function _onMouseUp()
{
  if( window.getSelection)
  {
    this.firstChild.style.left = 1;
    this.firstChild.style.top = 1;
    this.style.border="outset 2px";
  }
  else if (document.selection)
  {
    el = getReal(window.event.srcElement, "className", this.className);
    var cDisabled = el.getAttribute("cDisabled");
    cDisabled = (cDisabled != null);
    if ((el.className == this.className) && !cDisabled)
    {
      makeRaised(el);
    }
  }
}

function getReal(el, type, value)
{
  temp = el;
  while ((temp != null) && (temp.tagName != "BODY"))
  {
    if (eval("temp." + type) == value)
    {
      el = temp;
      return el;
    }
    temp = temp.parentElement;
  }
  return el;
}

function makeFlat(el)
{
  with (el.style)
    {
      background = "";
      border = "0px solid";
      padding      = "2px";
    }
}

function makeRaised(el)
{
  with (el.style)
    {
      borderLeft   = "1px solid #ffffff";
      borderRight  = "1px solid #555533";
      borderTop    = "1px solid #ffffff";
      borderBottom = "1px solid #555533";
      padding      = "1px";
    }
}

function makePressed(el)
{
  with (el.style)
    {
      borderLeft   = "1px solid #555533";
      borderRight  = "1px solid #ffffff";
      borderTop    = "1px solid #555533";
      borderBottom = "1px solid #ffffff";
      paddingTop    = "2px";
      paddingLeft   = "2px";
      paddingBottom = "0px";
      paddingRight  = "0px";
    }
}

function _createHyperlink(promptStr)
{
  if (this.mode == "TEXT_MODE")
    return;

  var cWin = document.getElementById(this.beanId).contentWindow;

  if( this.browserFlag == "Mozilla" )
  {
    var link = prompt(promptStr, anchor ? anchor.href : "http://");

    if ((link != null) && (link != "") && link != "http://")
    {
      cWin.document.execCommand("CreateLink", false, link);
    }

  }
  else
  {
    cWin.focus();

    var selection = cWin.document.selection;
    var selType = selection.type;

    var parent;

    if (selType == "Control")
    {
      parent = selection.createRange().item(0);
    }
    else
    {
      parent = selection.createRange().parentElement();
    }

    var anchor = getNode("A", parent);
    var link = prompt(promptStr, anchor ? anchor.href : "http://");
    if (link && link != "http://")
    {
      if (selType == "None")
      {
        var range = selection.createRange();
        range.pasteHTML('<A HREF="' + link + '"></A>');
        range.select();
      }
      else
      {
        this.execHTMLCommand("CreateLink",link);
      }
    }
  }
}


function getNode(tagName, start)
{
  while (start && start.tagName != tagName)
  {
    start = start.parentElement;
  }
  return start;
}

function _execHTMLCommand(HTMLCommand)
{
  if (this.mode == "TEXT_MODE")
    return;

  var cWin = document.getElementById(this.beanId).contentWindow;
  var cDoc = cWin.document;

  if (this.browserFlag == "Mozilla")
  {
    cDoc.execCommand('useCSS', false, true);
  }
  cWin.focus();
  cDoc.execCommand(HTMLCommand, false, arguments[1]);
  cWin.focus();
}

function _setFontBarDropdown(dropDownName, dropDownType)
{
  var obj = this.getField(dropDownName);
  this.execHTMLCommand(dropDownType,obj.options[obj.selectedIndex].value);
}


function _insertHTMLTag(tagString)
{
  if (this.mode == "TEXT_MODE")
    return;
  var cWin = document.getElementById(this.beanId).contentWindow;
  if (this.browserFlag == "IE_Win")
  {
    cWin.focus();
    var range = cWin.document.selection.createRange();
    //  range.collapse(false);
    range.pasteHTML(tagString);
    range.select();
    cWin.focus();
  }
  else if (this.browserFlag == "Mozilla")
  {
    // get current selection
    var sel = cWin.getSelection();

    // get the first range of the selection
    // (there's almost always only one range)
    var range = sel.getRangeAt(0);

    // deselect everything
    sel.removeAllRanges();

    // remove content of current selection from document
    range.deleteContents();

    // get location of current selection
    var container = range.startContainer;
    var pos = range.startOffset;

    // make a new range for the new selection
    range = document.createRange();

    // when inserting into a textnode
    // we create 2 new textnodes
    // and put the insertNode in between

    var textNode = container;
    container = textNode.parentNode;
    var text = textNode.nodeValue;

    // text before the split
    var textBefore = text.substr(0,pos);
    // text after the split
    var textAfter = text.substr(pos);

    var beforeNode = document.createTextNode(textBefore);
    var afterNode = document.createTextNode(textAfter);

    // insert the 3 new nodes before the old one
    container.insertBefore(afterNode, textNode);
    var insertNode = document.createElement(tagString);
    container.insertBefore(insertNode, afterNode);
    container.insertBefore(beforeNode, insertNode);

    // remove the old node
    container.removeChild(textNode);
  }
}

function _insertText(value)
{
  var cWin = document.getElementById(this.beanId).contentWindow;
  if (this.browserFlag == "IE_Win")
  {
    cWin.focus();
    var range = cWin.document.selection.createRange();
    // range.collapse(false);
    // range.pasteHTML(value);
    range.text=value;
    range.select();
    cWin.focus();
  }
  else if (this.browserFlag == "Mozilla")
  {
    // get current selection
    var sel = cWin.getSelection();

    // get the first range of the selection
    // (there's almost always only one range)
    var range = sel.getRangeAt(0);

    // deselect everything
    sel.removeAllRanges();

    // remove content of current selection from document
    range.deleteContents();

    // get location of current selection
    var container = range.startContainer;
    var pos = range.startOffset;

    // make a new range for the new selection
    range = document.createRange();

    // if we insert text in a textnode, do optimized insertion
    container.insertData(pos, value);

    // put cursor after inserted text
    range.setEnd(container, pos+value.length);
    range.setStart(container, pos+value.length);
    sel.addRange(range);
  }
  else
  {
    var node = this.getField(this.dataBeanId);
    node.value = node.value + " " + value;
  }
}



function _getField(p_strObjName)
{
  var obj = eval("document.forms[this.formName].elements['"+p_strObjName+"']");
  return obj;
}

function _validateContent()
{
  // ensure value has been transferred to hidden form field
  this.setContentOnBlur();

  return this.checkRTEDataLength();
}

function _setContentOnBlur()
{
  var l_objElements = document.forms[this.formName].elements;
  for (i = 0; i < l_objElements.length; i++)
  {
    var elemName = l_objElements[i].name;
    if (elemName == this.dataBeanId)
    {
      var contentField = l_objElements[i];
      if (document.getElementById(this.beanId).contentWindow != undefined)
      {
        if ( this.mode == "TEXT_MODE" )
          contentField.value = document.getElementById(this.beanId).contentWindow.document.body.innerText;
        else
          contentField.value = document.getElementById(this.beanId).contentWindow.document.body.innerHTML;
      }
    }
  }
  return true;
}

function _insertImageTag(imageSrc)
{
  if (this.mode == "TEXT_MODE")
    return;
  if (this.browserFlag == "IE_Win")
  {
    document.getElementById(this.beanId).contentWindow.focus();
    if (document.getElementById(this.beanId).contentWindow.document.selection.type != "None")
    {
      var parent = document.getElementById(this.beanId).contentWindow.document.selection.createRange().parentElement();
    }
    var parent = document.getElementById(this.beanId).contentWindow.document.selection.createRange().parentElement();
    var image = getNode("IMG", parent);
    if (imageSrc && imageSrc != "http://")
    {
      if (document.getElementById(this.beanId).contentWindow.document.selection.type == "None")
      {
        var range = document.getElementById(this.beanId).contentWindow.document.selection.createRange();
        range.pasteHTML('<IMG SRC="' + imageSrc + '">');
        range.select();
      }
      else
      {
        this.execHTMLCommand("insertImage", imageSrc);
      }
    }
  }
  else if (this.browserFlag == "Mozilla")
  {

    if ((imageSrc != null)
        && (imageSrc != "")
        && imageSrc != "http://")
    {
      document.getElementById(this.beanId).contentWindow.document.execCommand('InsertImage', false, imageSrc);
    }
  }
}

function _setValue(data)
{
  if((this.browserFlag == "Mozilla") || (this.browserFlag == "IE_Win"))
  {
    document.getElementById(this.beanId).contentWindow.focus();
    if (this.mode == "TEXT_MODE")
      document.getElementById(this.beanId).contentWindow.document.body.innerText  = data;
    else
      document.getElementById(this.beanId).contentWindow.document.body.innerHTML= data;
    document.getElementById(this.beanId).contentWindow.focus();
  }
  else
  {
    var node = this.getField(this.dataBeanId);
    node.value = data;
  }
}

function _setHref(url)
{
  if (this.mode == "TEXT_MODE")
    return;
  var cWin = document.getElementById(this.beanId).contentWindow;

  if (this.browserFlag == "IE_Win")
  {
    cWin.focus();
    var sel = cWin.document.selection;
    if (sel.type == "None")
    {
      var range = sel.createRange();
      range.pasteHTML('<A HREF="' + url + '"></A>');
      range.select();
    }
    else
    {
      this.execHTMLCommand("CreateLink", url);
    }
  }
  else if (this.browserFlag == "Mozilla")
  {
    cWin.document.execCommand("CreateLink", false, url);
  }
}

function _viewHtmlSource(mode)
{
  var bod = document.getElementById(this.beanId).contentWindow.document.body;
  if (mode)
  {
    this.disableFontDropDowns(true);
    this.mode = "TEXT_MODE";

    if (this.browserFlag == "IE_Win")
    {
      bod.innerText = bod.innerHTML;
    }
    else
    {
      var html = document.createTextNode(bod.innerHTML);
      bod.innerHTML = "";
      bod.appendChild(html);
    }
  }
  else
  {
    this.disableFontDropDowns(false);
    this.mode = "RICH_TEXT_MODE";
    if (this.browserFlag == "IE_Win")
    {
      bod.innerHTML = bod.innerText;
    }
    else
    {
      var html = bod.ownerDocument.createRange();
      html.selectNodeContents(bod);
      bod.innerHTML = html.toString();
    }
  }
  document.getElementById(this.beanId).contentWindow.focus();
}


function _disableFontDropDowns(flag)
{
  var fontDD = this.getField(this.dataBeanId + 'fontFamily');
  if (fontDD != null)
    fontDD.disabled = flag;

  var fontColorDD = this.getField(this.dataBeanId + 'fontColor');
  if (fontColorDD != null)
    fontColorDD.disabled = flag;

  var fontWeightDD = this.getField(this.dataBeanId + 'fontWeight');
  if (fontWeightDD != null)
    fontWeightDD.disabled = flag;
}


function _checkRTEDataLength ()
{
  if ( this.maxLength == -1 )  //DataType is CLOB
    return true;

  if (this.mode == "TEXT_MODE")
    data = document.getElementById(this.beanId).contentWindow.document.body.innerText;
  else
    data = document.getElementById(this.beanId).contentWindow.document.body.innerHTML;

  dataLength = data.length;
  //alert("sam : " + dataLength + ":" + this.maxLength);
  if (dataLength > this.maxLength)
  {
    //if (this.mode == "TEXT_MODE")
    //    frames[this.beanId].document.body.innerText = data.substr(0, this.maxLength);
    //else
    //    frames[this.beanId].document.body.innerHTML = data.substr(0, this.maxLength);
    return false;
  }

  if (dataLength < this.maxLength)
    return true;

  if (dataLength == this.maxLength)
    return true;

  return false;
}

function _setMaxLengthAlert (maxLengthAlertMsgStr)
{
  this.maxLengthAlertMsgStr = maxLengthAlertMsgStr;
}

function _getMaxLengthAlert ()
{
  return this.maxLengthAlertMsgStr;
}
// ----- END: APIs for Rich Text Editor (Owner: Anil Ranka, Vishal Save) -----
